<template>
  <el-dialog title="Upload audio files" :visible.sync="dialogVisible" @close="cancelForm()">
    <el-upload class="file-dropzone" ref="upload" action="/calls/upload" drag :auto-upload="false" multiple
               :show-file-list="false" :on-change="addFile" :on-success="submitForm">
      <i class="el-icon-upload"></i>
      <div class="el-upload__text" style="width: 100%">Drop files here or <em>click to upload</em></div>
      <!-- <div class="el-upload__tip" slot="tip">Only audio files</div> -->
    </el-upload>

    <el-card v-for="call in calls" :key="call.key" style="margin: 10px 0">
      <div slot="header">
        <span>{{call.filename}}</span>
        <el-button-group style="float: right; padding: 0 3px">
          <el-button plain size="mini" @click="removeFile(call.key)">remove</el-button>
        </el-button-group>
      </div>

      <el-form>
        <el-form-item label="Made at" prop="madeAt">
          <el-date-picker v-model="call.madeAt" type="datetime" style="width: 100%"></el-date-picker>
        </el-form-item>

        <el-form-item label="Agent" prop="agentId">
          <el-select v-model="call.agentId" style="width: 100%">
            <el-option v-for="agent in agents" :key="agent.id" :label="agent.username" :value="agent.id"></el-option>
          </el-select>
        </el-form-item>
      </el-form>

      <div v-if="call.file">Audio: <el-progress :percentage="call.file.progress"></el-progress></div>
      <div v-if="call.csv_file">CSV: <el-progress :percentage="call.csv_file.progress"></el-progress></div>
    </el-card>

    <span slot="footer" class="dialog-footer">
      <el-button @click="cancelForm()">Cancel</el-button>
      <el-button type="primary" @click="uploadFiles()">Upload</el-button>
    </span>
  </el-dialog>
</template>

<script>
import gql from 'graphql-tag'

export default {
  apollo: {
    agents: {
      query: gql`{ users (role: "agent") { id username profile { firstName lastName } } }`,
      update({ users }) { return  users }
    }
  },

  data() {
    return { dialogVisible: true, calls: [], agents: [], errors: [] }
  },

  methods: {
    addFile(file, fileList) {
      if (!file.raw.type.match(/(^audio\/|^text\/csv$)/)) {
        this.$message.error('The files must be in audio or csv type!')
        return
      }

      for(var i in this.$data.calls) {
        if((this.$data.calls[i].file && this.$data.calls[i].file.name == file.name) || (this.$data.calls[i].csv_file && this.$data.calls[i].csv_file.name == file.name)) {
          fileList.pop()
          // this.$message.error('You can\'t upload the same file twice!')
          return
        }
        else if(file.raw.type.match(/^text\/csv$/) && this.$data.calls[i].file && file.name.replace(/\.[^/.]+$/, "") == this.$data.calls[i].file.name) {
          this.$data.calls[i].csv_file = file

          fileList.pop()
          fileList.unshift(file)

          return file
        }
        else if(file.raw.type.match(/^audio\//) && this.$data.calls[i].csv_file && file.name + '.csv' == this.$data.calls[i].csv_file.name) {
          this.$data.calls[i].file = file

          return file
        }
      }

      let key = 0
      if(this.$data.calls.length > 0)
        key = this.$data.calls[this.$data.calls.length - 1].key + 1

      let call = { key: key, filename: null, file: null, csv_file: null, id: null, madeAt: file.raw.lastModifiedDate, agentId: null }
      if(file.raw.type.match(/^audio\//)) {
        call.file = file
        call.filename = file.name
      }
      else if(file.raw.type.match(/^text\/csv$/)) {
        call.csv_file = file
        call.filename = file.name.replace(/\.[^/.]+$/, "")
      }

      this.$data.calls.push(call)

      return file
    },
    removeFile(key) {
      this.$data.calls.forEach((call, index, array) => {
        if(call.key == key){
          this.$data.calls.splice(index, 1)
          this.$refs.upload.$data.uploadFiles.splice(index, 1)
        }
      })
    },
    uploadFiles() {
      this.$refs.upload.submit()
    },
    submitForm(response, file, fileList) {
      if(response.success) {
        this.$data.calls.forEach((call, index, array) => {
          if((call.file && call.file.name == file.name) || (call.csv_file && call.csv_file.name == file.name)) {
            this.$apollo.mutate({
              mutation: gql`mutation ($call: CallInput!) {
                updateCall(call: $call) {
                  success
                  message
                  errors { field message }
                }
              }`,
              variables: { call: { id: response.call.id, madeAt: call.madeAt, agentId: call.agentId } },
              update: (store, { data: { updateCall } }) => {
                if(updateCall.success) {
                  this.$message.success('Call saved successfully')

                  if(call.file && call.file.name == file.name)
                    this.$data.calls[index].file = null
                  else if(call.csv_file && call.csv_file.name == file.name)
                    this.$data.calls[index].csv_file = null
                  
                  if(!this.$data.calls[index].file && !this.$data.calls[index].csv_file)
                    this.$data.calls.splice(index, 1)

                  if(this.$data.calls.length == 0) {
                    this.$data.dialogVisible = false
                    this.$router.push('/calls')
                  }
                }
                else
                  this.$message.error('Failed to save call')
              }
            })
          }
        })
      }
      else
        this.$message.error('Failed to upload call')
    },
    cancelForm() {
      this.$data.dialogVisible = false
      this.$router.push('/calls')
    }
  }
}
</script>
